//+-------------------------------------------------------------------------------------------------------------------+
//|                                                                                  ZH_StandardFunctionsTfYR1.lib.mq4|
//|                                                                                  Copyright  Zhunko               |
//|01.07.2007                                                                        F ZHUNKO vadim@zhunko.ru        |
//+-------------------------------------------------------------------------------------------------------------------+
//|     YR1.                                                                                         |
//+-------------------------------------------------------------------------------------------------------------------+
//|1.    YR1.                                                                                       |
//|  int iBars_YR1 (string symbol); //   .                                                    |
//+-------------------------------------------------------------------------------------------------------------------+
//|2.      YR1.                                                                                  |
//|  int iBarShift_YR1 (string   symbol, //   .                                               |
//|                     datetime time,   //    .                                              |
//|                     bool     exact)  //                                        |
//|                                      // (FALSE - iBarShift  /TRUE - iBarShift  -1).  |
//+-------------------------------------------------------------------------------------------------------------------+
//|3.       YR1.                                                                          |
//|  datetime iTime_YR1 (string symbol, //   .                                                |
//|                      int    shift)  //  .                                                                |
//+-------------------------------------------------------------------------------------------------------------------+
//|4.      YR1.                                                                          |
//|  double iOpen_YR1 (string symbol, //   .                                                  |
//|                    int    shift)  //  .                                                                  |
//+-------------------------------------------------------------------------------------------------------------------+
//|5.      YR1.                                                                      |
//|  double iHigh_YR1 (string symbol, //   .                                                  |
//|                    int    shift)  //  .                                                                  |
//+-------------------------------------------------------------------------------------------------------------------+
//|6.      YR1.                                                                       |
//|  double iLow_YR1 (string symbol, //  .                                                               |
//|                   int    shift)  //  .                                                                   |
//+-------------------------------------------------------------------------------------------------------------------+
//|7.      YR1.                                                                          |
//|  double iClose_YR1 (string symbol, //   .                                                 |
//|                     int    shift)  //  .                                                                 |
//+-------------------------------------------------------------------------------------------------------------------+
#property copyright "Copyright  2006 Zhunko"
#property link      "vadim@zhunko.ru"
#property library
//
//      YR1. 
//
// 1.     YR1.
int iBars_YR1 (string symbol) //   .
 {
  int i;
  int iBarsMN1;     //     MN1  .
  int iBarsYR1 = 0; //     YR1.
  //----
  iBarsMN1 = iBars (symbol, PERIOD_MN1); //     MN1  .
  for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
  return (iBarsYR1);
 }
//
// 2.       YR1.
int iBarShift_YR1 (string   symbol, //   .
                   datetime time,   //    .
                   bool     exact)  //       (FALSE - iBarShift  /TRUE - iBarShift  -1).
 {
  bool     Coincidence = false;
  datetime iTimeMN1_0;   //      MN1.
  datetime iTimeMN1_1;   //      MN1.
  int      i;
  int      iBarsYR1 = 0; //     YR1.
  int      iBarsMN1;     //     MN1  .
  int      FirstYear;    //     .  
  int      ShiftYR1 = 0; //  .
  //----
  iBarsMN1 = iBars (symbol, PERIOD_MN1);                       //     MN1  .
  FirstYear = StrToInteger (StringSubstr (TimeToStr (iTime (symbol, PERIOD_MN1, iBarsMN1 - 1), TIME_DATE), 0, 4)); //     .
  if (TimeYear (time) < FirstYear || Year() < TimeYear (time)) //     ,             . 
   {
    if (exact == false)                                        //   ,      (    ).
     {//    ,    ,      .
      if (TimeYear (time) < FirstYear) return (Year() - FirstYear);
      if (TimeYear (time) > Year()) return (0);                //    ,    ,      .
     }
    else return (-1);                                          //   ,   -1    .
   }
  else                                                         //         ,         .
   {
    if (exact == true)                                         //   ,   -1    .
     {
      for (i = 0, ShiftYR1 = 0; i < iBarsMN1; i++)
       {//    ,  .
        if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) ShiftYR1++;
        //           .
        if (TimeYear (time) == TimeYear (iTime (symbol, PERIOD_MN1, i)))
         {
          Coincidence = true;
          break;
         }
       }
      if (Coincidence == false) return (-1);                   //      ,  -1.
     }
    else                                                       //   ,       () .
     {//      YR1.
      for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
      for (i = 0, ShiftYR1 = -1; i < iBarsMN1; i++)
       {
        iTimeMN1_0 = iTime (symbol, PERIOD_MN1, i);
        iTimeMN1_1 = iTime (symbol, PERIOD_MN1, i + 1);
        if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0)
         {
          ShiftYR1++;
          if (ShiftYR1 == 0)                                   //       .
           {//           .
            if (TimeYear (time) == TimeYear (iTimeMN1_0)) return (ShiftYR1);
            else
             {
              if (TimeYear (iTimeMN1_1) < TimeYear (time))     //     .
               {
                ShiftYR1++;                                    //   ,   .
                return (ShiftYR1);
               }
             }
           }
          if (0 < ShiftYR1 && ShiftYR1 < iBarsYR1)             //    ""         .
           {//           .
            if (TimeYear (time) == TimeYear (iTimeMN1_0)) return (ShiftYR1);
            else                                               //      ,     .
             {
              if (TimeYear (iTimeMN1_1) < TimeYear (time) && TimeYear (time) < TimeYear (iTimeMN1_0))
               {
                ShiftYR1++;                                    //   ,   .
                return (ShiftYR1);
               }
             }
           }
          if (ShiftYR1 == iBarsYR1) return (ShiftYR1);         //   ,    ,   .
         }
       }
     }
   }
 }
//
// 3.        YR1.
datetime iTime_YR1 (string symbol, //   
                    int    shift)  //  .
 {
  int i;
  int iBarsYR1;      //     .
  int ShiftYR1 = -1; //     YR1.
  //----
  int iBarsMN1 = iBars (symbol, PERIOD_MN1);                                       //     MN1  .
  //     YR1  .
  for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
  if (0 > shift || shift >= iBarsYR1) return (0);                                  //     .
  else
   {
    for (i = 0; i < iBarsMN1; i++)
     {
      datetime iTimeMN1_0 = iTime (symbol, PERIOD_MN1, i);                         //      MN1.
      datetime iTimeMN1_1 = iTime (symbol, PERIOD_MN1, i + 1);                     //      MN1.
      if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) //     ,      .
       {
        ShiftYR1++;
        if (shift == ShiftYR1) return (iTimeMN1_0);
       }
     }
   }
 }
//
// 4.       YR1.
double iOpen_YR1 (string symbol, //   .
                  int    shift)  //  .
 {
  int i;
  int iBarsYR1;      //     .
  int ShiftYR1 = -1; //     YR1.
  //----
  int iBarsMN1 = iBars (symbol, PERIOD_MN1);                                       //     MN1  .
  //     YR1  .
  for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
  if (0 > shift || shift >= iBarsYR1) return (0);                                  //     .
  else
   {
    for (i = 0; i < iBarsMN1; i++)
     {
      datetime iTimeMN1_0 = iTime (symbol, PERIOD_MN1, i);                         //      MN1.
      datetime iTimeMN1_1 = iTime (symbol, PERIOD_MN1, i + 1);                     //      MN1.
      if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) //     ,      .
       {
        ShiftYR1++;
        if (shift == ShiftYR1) return (iOpen (symbol, PERIOD_MN1, i));             //      .
       }
     }
   }
 }
//
// 5.       YR1.
double iHigh_YR1 (string symbol, //   .
                  int    shift)  //  .
 {
  datetime iTimeMN1_0;
  datetime iTimeMN1_1;
  double   ArrayHighMN1[12]; //  .
  int      iBarsYR1;         //     .
  int      i, j, k;
  int      ShiftYR1 = 0;     //     YR1.
  //----
  int iBarsMN1 = iBars (symbol, PERIOD_MN1);                                               //     MN1  .
  //     YR1  .
  for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
  if (0 > shift || shift > iBarsYR1 - 1) return (0);                                       //     .
  else
   {
    if (shift == 0)                                                                        //   ,    .
     {
      for (j = 0, k = 0; j < 12; j++)
       {
        ArrayHighMN1[k] = iHigh (symbol, PERIOD_MN1, j);                                   //    .
        iTimeMN1_0 = iTime (symbol, PERIOD_MN1, j);                                        //      MN1.
        iTimeMN1_1 = iTime (symbol, PERIOD_MN1, j + 1);                                    //      MN1.
        k++;                                                                               //   .
        //     ,      .  .  .
        if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) return (ArrayHighMN1[ArrayMaximum (ArrayHighMN1, k, 0)]);
       }
     }
    if (0 < shift || shift < iBarsYR1)                                     
     {  
      for (i = 0; i < iBarsMN1; i++)
       {
        iTimeMN1_0 = iTime (symbol, PERIOD_MN1, i);                                        //      MN1.
        iTimeMN1_1 = iTime (symbol, PERIOD_MN1, i + 1);                                    //      MN1.
        if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0)       //     ,      .  .
         {
          ShiftYR1++;
          if (shift == ShiftYR1)
           {
            for (j = i + 1, k = 0; j < i + 13; j++)
             {
              ArrayHighMN1[k] = iHigh (symbol, PERIOD_MN1, j);                             //    .
              iTimeMN1_0 = iTime (symbol, PERIOD_MN1, j);                                  //      MN1.
              iTimeMN1_1 = iTime (symbol, PERIOD_MN1, j + 1);                              //      MN1.
              k++;                                                                         //   .
              //     ,      .  .  .
              if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) return (ArrayHighMN1[ArrayMaximum (ArrayHighMN1, k, 0)]);
             }
           }
         }
       }
     }    
   }
 }
//
// 6.       YR1.
double iLow_YR1 (string symbol, //  .
                 int    shift)  //  .
 {
  datetime iTimeMN1_0;
  datetime iTimeMN1_1;
  double   ArrayLowMN1[12]; //  .
  int      iBarsYR1;        //     .
  int      i, j, k;
  int      ShiftYR1 = 0;    //     YR1.
  //----
  int iBarsMN1 = iBars (symbol, PERIOD_MN1);                                               //     MN1  .
  //     YR1  .
  for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
  if (0 > shift || shift > iBarsYR1 - 1) return (0);                                       //     .
  else
   {
    if (shift == 0)                                                                        //   ,    .
     {
      for (j = 0, k = 0; j < 12; j++)
       {
        ArrayLowMN1[k] = iLow (symbol, PERIOD_MN1, j);
        iTimeMN1_0 = iTime (symbol, PERIOD_MN1, j);                                        //      MN1.
        iTimeMN1_1 = iTime (symbol, PERIOD_MN1, j + 1);                                    //      MN1.
        k++;                                                                               //   .
        //     ,      .  .  .
        if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) return (ArrayLowMN1[ArrayMinimum (ArrayLowMN1, k, 0)]);
       }
     }
    if (0 < shift || shift < iBarsYR1)
     {
      for (i = 0; i < iBarsMN1; i++)
       {
        iTimeMN1_0 = iTime (symbol, PERIOD_MN1, i);                                        //      MN1.
        iTimeMN1_1 = iTime (symbol, PERIOD_MN1, i + 1);                                    //      MN1.
        if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0)       //     ,      .  .
         {
          ShiftYR1++;
          if (shift == ShiftYR1)
           {
            for (j = i + 1, k = 0; j < i + 13; j++)
             {
              ArrayLowMN1[k] = iLow (symbol, PERIOD_MN1, j);
              iTimeMN1_0 = iTime (symbol, PERIOD_MN1, j);                                  //      MN1.
              iTimeMN1_1 = iTime (symbol, PERIOD_MN1, j + 1);                              //      MN1.
              k++;                                                                         //   .
              //     ,      .  .  .
              if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) return (ArrayLowMN1[ArrayMinimum (ArrayLowMN1, k, 0)]);
             }
           }
         }
       }
     }
   }
 }
//
// 7.       YR1.
double iClose_YR1 (string symbol, //   .
                   int    shift)  //  .
 {
  int i;
  int iBarsYR1;     //     .
  int ShiftYR1 = 0; //     YR1.
  //----
  int iBarsMN1 = iBars (symbol, PERIOD_MN1);                                         //     MN1  .
  //     YR1  .
  for (i = 0; i < iBarsMN1; i++) if (MathMod (TimeYear (1.0 * iTime (symbol, PERIOD_MN1, i)), 1.0 * TimeYear (iTime (symbol, PERIOD_MN1, i + 1))) != 0) iBarsYR1++;
  if (shift < 0 || shift >= iBarsYR1) return (0);                                    //     .
  else
   {
    if (shift == 0) return (iClose (symbol, PERIOD_MN1, 0));                         //   ,          .
    else                                                                             //    ,         .
     {
      for (i = 0; i < iBarsMN1; i++)
       {
        datetime iTimeMN1_0 = iTime (symbol, PERIOD_MN1, i);                         //      MN1.
        datetime iTimeMN1_1 = iTime (symbol, PERIOD_MN1, i + 1);                     //      MN1.
        if (MathMod (TimeYear (1.0 * iTimeMN1_0), 1.0 * TimeYear (iTimeMN1_1)) != 0) //     ,      .
         {
          ShiftYR1++;
          if (shift == ShiftYR1) return (iClose (symbol, PERIOD_MN1, i + 1));        //      .
         }
       }
     }
   }
 }
//